// Generated by CoffeeScript 1.10.0
(function() {
  var assembly, calculator, copper, courtyard, silkscreen;

  assembly = require('./common/assembly');

  calculator = require('./common/calculator');

  copper = require('./common/copper');

  courtyard = require('./common/courtyard');

  silkscreen = require('./common/silkscreen');

  module.exports = function(pattern, element) {
    var housing, i, j, len, p, pad, points;
    housing = element.housing;
    if (pattern.name == null) {
      pattern.name = element.name.toUpperCase();
    }
    if (housing.drillDiameter != null) {
      pad = {
        type: 'through-hole',
        drill: housing.drillDiameter,
        width: housing.padWidth,
        height: housing.padHeight,
        shape: 'rectangle',
        layer: ['topCopper', 'topMask', 'topPaste', 'bottomCopper', 'bottomMask', 'bottomPaste']
      };
    } else {
      pad = {
        type: 'smd',
        width: housing.padWidth,
        height: housing.padHeight,
        shape: 'rectangle',
        layer: ['topCopper', 'topMask', 'topPaste']
      };
    }
    points = copper.parsePosition(housing.padPosition);
    for (i = j = 0, len = points.length; j < len; i = ++j) {
      p = points[i];
      pad.x = p.x;
      pad.y = p.y;
      pattern.pad(i + 1, pad);
      if (housing.drillDiameter != null) {
        pad.shape = 'circle';
      }
    }
    silkscreen.body(pattern, housing);
    assembly.body(pattern, housing);
    return courtyard.body(pattern, housing);
  };

}).call(this);
